#include "ArithExp.h"

void write(ArithExp_exp_ty exp, outstream_ty outstream) {
	ArithExp_write_exp(exp, outstream);
}

ArithExp_exp_ty read(instream_ty instream) {
	return ArithExp_read_exp(instream);
}

int eval(ArithExp_exp_ty exp) {
	ArithExp_unop_enum_ty *uneg = ArithExp_Neg;
	ArithExp_unop_enum_ty *usign = ArithExp_Sign;
	ArithExp_unop_enum_ty *uabs = ArithExp_Abs;
	ArithExp_binop_enum_ty *bplus = ArithExp_Plus;
	ArithExp_binop_enum_ty *bminus = ArithExp_Minus;
	ArithExp_binop_enum_ty *bmult = ArithExp_Mult;
	ArithExp_binop_enum_ty *bdiv = ArithExp_Div;
	ArithExp_unop_enum_ty *ukind;
	ArithExp_binop_enum_ty *bkind;
	int v, v1, v2, r;

	switch (exp->kind) {
	case ArithExp_Value_enum:
		v = exp->u.ArithExp_Value.f0;
		printf("Value: %d\n", v);
		return v;
	case ArithExp_Unary_enum:
 		v = eval(exp->u.ArithExp_Unary.arg);
		ukind = (exp->u.ArithExp_Unary.operator);
		if (ukind == usign) {
			r = (v > 0) ? 1 : ((v < 0) ? -1 : 0);
	 		printf("Unary: Sign(%d) = %d\n", v, r);
			return r;
	 	} else
		if (ukind == uneg) {
			r = -v;
	 		printf("Unary: Neg(%d) = %d\n", v, r);
	 		return r;
	 	} else
		if (ukind == uabs) {
			r = abs(v);
	 		printf("Unary: Abs(%d) = %d\n", v, r);
	 		return r;
		} else printf("unknown Unary kind %d\n", *ukind);
	case ArithExp_Binary_enum:
 		v1 = eval(exp->u.ArithExp_Binary.arg1);
 		v2 = eval(exp->u.ArithExp_Binary.arg2);
		bkind = (exp->u.ArithExp_Binary.operator);
		if (bkind == bplus) {
			r = v1 + v2;
			printf("Binary: %d + %d = %d\n", v1, v2, r);
			return r;
		} else
		if (bkind == bminus) {
			r = v1 - v2;
			printf("Binary: %d - %d = %d\n", v1, v2, r);
			return r;
		} else
		if (bkind == bmult) {
			r = v1 * v2;
			printf("Binary: %d * %d = %d\n", v1, v2, r);
			return r;
	 	 } else
		if (bkind == bdiv) {
			r = v1 / v2;
			printf("Binary: %d / %d = %d\n", v1, v2, r);
			return r;
		} else printf("unknown Binary kind %d\n", *bkind);
	default:
		printf("unknown exp kind %d\n" + exp->kind);
		return 0;
	}
}
