#include "ArithExp.hxx"
#include <iostream>

int eval(ArithExp_exp* exp) {
	ArithExp_unop *uneg = ArithExp_Neg;
	ArithExp_unop *usign = ArithExp_Sign;
	ArithExp_unop *uabs = ArithExp_Abs;
	ArithExp_binop *bplus = ArithExp_Plus;
	ArithExp_binop *bminus = ArithExp_Minus;
	ArithExp_binop *bmult = ArithExp_Mult;
	ArithExp_binop *bdiv = ArithExp_Div;
	ArithExp_unop *ukind;
	ArithExp_binop *bkind;
	int v, v1, v2, r;

	switch (exp->kind_()) {
	case ArithExp_exp::ArithExp_Value_enum:
		v = static_cast<ArithExp_Value*>(exp)->f0;
		std::cout << "Value: " << v << std::endl;
		return v;
	case ArithExp_exp::ArithExp_Unary_enum:
 		v = eval(static_cast<ArithExp_Unary*>(exp)->arg);
		ukind = (static_cast<ArithExp_Unary*>(exp)->operator_);
		if (ukind == usign) {
			r = (v > 0) ? 1 : ((v < 0) ? -1 : 0);
	 		std::cout << "Unary: Sign(" << v << ") = " << r << std::endl;
			return r;
	 	} else
		if (ukind == uneg) {
			r = -v;
	 		std::cout << "Unary: Neg(" << v << ") = " << r << std::endl;
	 		return r;
	 	} else
		if (ukind == uabs) {
			r = abs(v);
	 		std::cout << "Unary: Abs(" << v << ") = " << r << std::endl;
	 		return r;
		} else std::cout << "unknown Unary kind " << (ukind->kind_()) << std::endl;
	case ArithExp_exp::ArithExp_Binary_enum:
 		v1 = eval(static_cast<ArithExp_Binary*>(exp)->arg1);
		v2 = eval(static_cast<ArithExp_Binary*>(exp)->arg2);
		bkind = (static_cast<ArithExp_Binary*>(exp)->operator_);
		if (bkind == bplus) {
			r = v1 + v2;
	 		std::cout << "Binary: " << v1 << " + " << v2 << " = " << r << std::endl;
			return r;
		} else
		if (bkind == bminus) {
			r = v1 - v2;
	 		std::cout << "Binary: " << v1 << " - " << v2 << " = " << r << std::endl;
			return r;
		} else
		if (bkind == bmult) {
			r = v1 * v2;
	 		std::cout << "Binary: " << v1 << " * " << v2 << " = " << r << std::endl;
			return r;
	 	 } else
		if (bkind == bdiv) {
			r = v1 / v2;
	 		std::cout << "Binary: " << v1 << " / " << v2 << " = " << r << std::endl;
			return r;
		} else std::cout << "unknown Binary kind " << (bkind->kind_()) << std::endl;
	default:
		std::cout << "unknown exp kind " << (exp->kind_()) << std::endl;
		return 0;
	}
}
