import asts.arithexp.*;

public class EvalArithExp {
    public static int eval(exp e) {
	int uneg = asts.arithexp.g.Neg.kind_();
	int usign = asts.arithexp.g.Sign.kind_();
	int uabs = asts.arithexp.g.Abs.kind_();
	int bplus = asts.arithexp.g.Plus.kind_();
	int bminus = asts.arithexp.g.Minus.kind_();
	int bmult = asts.arithexp.g.Mult.kind_();
	int bdiv = asts.arithexp.g.Div.kind_();
	int ukind, bkind, v, v1, v2, r;

	switch (e.kind_()) {
	case exp.Value_enum:
		v = ((Value)e).f0;
		System.out.println("Value: " + v);
		return v;
	case exp.Unary_enum:
 		v = eval(((Unary)e).arg);
		ukind = ((((Unary)e).operator).kind_());
		if (ukind == usign) {
			r = Integer.signum(v);
	 		System.out.println("Unary: Sign(" + v + ") = " + r);
			return r;
	 	} else
		if (ukind == uneg) {
			r = -v;
			System.out.println("Unary: Neg(" + v + ") = " + r);
	 		return r;
	 	} else
		if (ukind == uabs) {
			r = Integer.signum(v) * v;
			System.out.println("Unary: Abs(" + v + ") = " + r);
	 		return r;
		} else throw new Error("unknown Unary kind " + ukind);
	case exp.Binary_enum:
 		v1 = eval(((Binary)e).arg1);
 		v2 = eval(((Binary)e).arg2);
		bkind = ((((Binary)e).operator).kind_());
		if (bkind == bplus) {
			r = v1 + v2;
			System.out.println("Binary: " + v1 + " + " + v2 + " = " + r);
			return r;
		} else
		if (bkind == bminus) {
			r = v1 - v2;
			System.out.println("Binary: " + v1 + " - " + v2 + " = " + r);
			return r;
		} else
		if (bkind == bmult) {
			r = v1 * v2;
			System.out.println("Binary: " + v1 + " * " + v2 + " = " + r);
			return r;
	 	 } else
		if (bkind == bdiv) {
			r = v1 / v2;
			System.out.println("Binary: " + v1 + " / " + v2 + " = " + r);
			return r;
		} else return 0;
	default:
		System.out.println("unknown exp kind " + e.kind_());
		return 0;
	}
    }
}

