structure EvalArithExp =
struct
	local open ArithExp in
	
	fun unary {operator=Neg, arg} = ~ (eval arg)
	  | unary {operator=Sign, arg} = Int.sign (eval arg)
	  | unary {operator=Abs, arg} = Int.abs (eval arg)
	and binary {operator=Plus, arg1, arg2} = (eval arg1) + (eval arg2)
	  | binary {operator=Minus, arg1, arg2} = (eval arg1) - (eval arg2)
	  | binary {operator=Mult, arg1, arg2} = (eval arg1) * (eval arg2)
	  | binary {operator=Div, arg1, arg2} = (eval arg1) div (eval arg2)
	and eval (Value i) = i
	  | eval (Unary u) = unary u
	  | eval (Binary b) = binary b

	end

	local open ArithExpUtil in

	fun write exp fname =
		let val outstream = BinIO.openOut fname
		in write_exp exp outstream
			before BinIO.closeOut outstream
		end

	fun read fname =
		let val instream = BinIO.openIn fname
		in read_exp instream
			before BinIO.closeIn instream
		end

	end
end

